unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  TAGraph, TASeries, TANavigation, TAChartExtentLink;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Chart2: TChart;
    Chart2LineSeries1: TLineSeries;
    ChartExtentLink1: TChartExtentLink;
    ChartNavScrollBar1: TChartNavScrollBar;
    Panel1: TPanel;
    ToggleBox1: TToggleBox;
    procedure Chart1ExtentChanging(ASender: TChart);
    procedure Chart2ExtentChanging(ASender: TChart);
    procedure FormCreate(Sender: TObject);
    procedure ToggleBox1Click(Sender: TObject);
  private
    xStart: Double;
    procedure UpdateChartExtent(AChart: TChart);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math,
  TAChartUtils, TACustomSeries;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
const
  N = 1000;
  XMIN = -10;
  XMAX = 10;
var
  i: Integer;
  x, y: Double;
  ext: TDoubleRect;
begin
  for i:=0 to N-1 do begin
    x := XMIN + (XMAX - XMIN) * i / (N-1);
    y := sqr(x)*cos(x);
    Chart1LineSeries1.AddXY(x, y);
    y := sin(2*x);
    Chart2LineSeries1.AddXY(x, y);
  end;

  Chart1.Prepare;
  Chart2.Prepare;

  ext := Chart1.LogicalExtent;
  ext.A.X := ext.B.X - 1.0;
  Chart1.LogicalExtent := ext;

  ChartExtentLink1.AddChart(Chart1);
  ChartExtentLink1.AddChart(Chart2);
  ChartExtentLink1.SyncWith(Chart1);
  ChartExtentLink1.Enabled := true;
end;

procedure TForm1.ToggleBox1Click(Sender: TObject);
var
  ext: TDoubleRect;
begin
  if ToggleBox1.Checked then begin
    xStart := Chart1.LogicalExtent.A.X;
    Chart1.ZoomFull;
  end else begin
    ext := Chart1.LogicalExtent;
    ext.b.x := xstart + 1;
    ext.a.x := xstart;
    Chart1.LogicalExtent := ext;
  end;
end;

procedure TForm1.Chart1ExtentChanging(ASender: TChart);
begin
  UpdateChartExtent(Chart1);
end;

procedure TForm1.Chart2ExtentChanging(ASender: TChart);
begin
  UpdateChartExtent(Chart2);
end;

procedure TForm1.UpdateChartExtent(AChart: TChart);
var
  i,j: Integer;
  ser: TChartSeries;
  ymin, ymax: Double;
  ext: TDoubleRect;
begin
  ext := AChart.LogicalExtent;
  ymin := 1E308;
  ymax := -1E308;
  for i:=0 to AChart.SeriesCount-1 do
    if AChart.Series[i] is TChartSeries then begin
      ser := TChartSeries(AChart.Series[i]);
      for j := 0 to ser.Count - 1 do
        if InRange(ser.XValue[j], ext.a.x, ext.b.x) then begin
          ymin := Min(ymin, ser.YValue[j]);
          ymax := Max(ymax, ser.YValue[j]);
        end;
    end;
  ext.a.y := ymin;
  ext.b.y := ymax;
  AChart.LogicalExtent := ext;
end;

end.

